/*

    This file requires site.js to work

*/


var Site = Site || {},
    $body = $body || $("body");


    (function($){
        Site.Drawers = {
            onLoad: function() {
                $("[data-drawer]").off().on("click", Site.Drawers.onClick);
            },
            onClick: function(e) {
                e.preventDefault();

                var drawer = $(e.currentTarget).data("drawer"),
                $drawer = $(document.getElementById(drawer));

                if ( $body.hasClass("is-"+drawer+"-open") ) {
                    Site.Drawers.hideAll();
                    if(drawer === "close") return;
                    return;
                }
                else {
                    
                    Site.Drawers.hideAll();
                    if(drawer === "close") return;

                    $body.addClass("is-drawer-open")
                    .addClass("is-"+drawer+"-open");


                    if ( $drawer.find("input").length ) {
                        $drawer.find("input").val("").focus();
                    }
                }

            },
            hideAll: function() {
                $body.removeClass("is-drawer-open")
                .removeClass("is-search-open")
                .removeClass("is-info-open")
                .removeClass("is-menu-open");
            },
            onUnLoad: function() {
                Site.Drawers.hideAll();
            }
        };
    }(jQuery));

