/*

    This file requires site.js to work

*/


var Site = Site || {},
    $window = $window || $(window),
    $body = $body || $(body);


    (function($){

        var dur = 0.4;

        Site.GalleryView = {
            
            el: "#gallery",

            w: {
                // container size
            },

            states: {
                current:    0,
                enlarged:   false,
                loaded:     false,
                animating:  false,
                direction:  0,
                mobile:     false
            },

            images: {},

            template: '<img src="{{src}}" class="is-loading" {{zoom}}>',

            init: function() {
                Site.GalleryView.$el = $(Site.GalleryView.el);
                Site.GalleryView.defaultStates = jQuery.extend(true, {}, Site.GalleryView.states);
                Site.GalleryView.defaultTemplate = Site.GalleryView.$el.html();
            },

            onLoad: function() {

                if ( !$("#gallery").length ) return;
                Site.GalleryView.states = jQuery.extend(true, {}, Site.GalleryView.defaultStates);
                // Site.GalleryView.states.enlarged = false;
                // Site.GalleryView.states.current = 0;
                Site.GalleryView.initialize();

            },

            initialize: function() {

                Site.GalleryView.$el = $(Site.GalleryView.el);


                Site.GalleryView.images = Site.GalleryView.$el.data("gallery").images;

                Site.GalleryView.bindLinks();


              
                var i = 0,
                l = Site.GalleryView.images.length;

                for (i = 0; i< l; i++) {
                    if(Site.GalleryView.images[i].url === window.location.pathname) {
                        Site.GalleryView.states.current = i;
                        continue;
                    }
                }               

                Site.GalleryView.render();

            },

            bindLinks: function() {

                Site.GalleryView.$el.find(".gallery-next").off().on("click", 1, Site.GalleryView.showIndex);
                Site.GalleryView.$el.find(".gallery-prev").off().on("click", -1, Site.GalleryView.showIndex);
                $("#artist-info").off().on("click", Site.GalleryView.unEnlarge);

            },

            render: function() {

                console.log("rendering");

                if ( Site.Layout.isMobile ) {
                    Site.GalleryView.Mobile.render(); return;
                }

                // Site.GalleryView.$el.html(Site.GalleryView.defaultTemplate);

                Site.GalleryView.bindLinks();

                Site.GalleryView.states.mobile = false;

                var img = Site.GalleryView.images[Site.GalleryView.states.current];


                if (!img) return

                Site.GalleryView.destroyVideo();

                var
                imgSrc = img.src,
                info = img.title + "<br>" + img.description,
                zoom = "";

                Site.GalleryView.$el.find("img").remove();


                if ( "zoomSrc" in img && "zoomWidth" in img && "zoomHeight" in img ) {
                    zoom = 'data-zoom=\'{"src": "'+img.zoomSrc+'", "width": '+img.zoomWidth+', "height": '+img.zoomHeight+'}\'';
                }

                Site.GalleryView.$el.append( 
                    Site.GalleryView.template.replace("{{src}}", imgSrc)
                    .replace("{{zoom}}", zoom)
                );

                Site.GalleryView.$el.find(".gallery-info").html( info );

                // Handle Videos
                if (! "vimeoId" in img ) img.vimeoId = "";

                if (img.vimeoId !== "") { 
                    Site.GalleryView.states.loaded = true;
                    Site.GalleryView.createVideo( img.vimeoId );
                    // Site.GalleryView.setVideoSize(false);

                    Site.GalleryView.$el.find("img").remove();
                    Site.GalleryView.doResize();
                }
                else {
                    Site.GalleryView.showImg();
                }

                // Handle work description
                if (! "info_work" in img ) img.info_work = "";

                document.getElementById("artist-info-work").innerHTML = img.info_work;

                if ( "url" in img ) {
                    Site.PushStates.noChange = true;
                    Site.PushStates.goTo(img.url);
                    Site.PushStates.noChange = false;
                }             

                if ( "page_title" in img ) {
                    Site.PushStates.setTitle(img.page_title);
                }
           

            },

            videoCode: '<iframe id="vimeo" src="//player.vimeo.com/video/{{id}}?title=0&amp;byline=0&amp;portrait=0&amp;color=ffffff" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>',
            
            createVideo: function(vimeoId) {

                $(Site.GalleryView.videoCode.replace("{{id}}", vimeoId))
                .appendTo($("#gallery"));


                // Site.GalleryView.setVideoSize ( false );

                setTimeout(Site.GalleryView.setVideoSize, 500);
                
            },

            destroyVideo: function() {
                $("#vimeo").remove();
            },

            showImg: function() {

                var el = $("#gallery").children().filter("img");

                el.imagesLoaded(function() {
                    Site.GalleryView.onImageLoad(el)
                });

            },

            onImageLoad: function($img) {

                  

                    Site.GalleryView.states.loaded = true;


                    $img.data("width", $img.width())
                    .data("height", $img.height())
                    .removeClass("is-loading");

                    var x = (Site.GalleryView.states.direction !== 0) ? Site.GalleryView.states.direction*200 : 0;

                    // var x = 0;

                    TweenMax.from($img, 0.3, {opacity: 0, x: x, y: 0, z: 0});

                    Site.GalleryView.states.direction = 0;


                    Site.GalleryView.doResize();

                    Site.Zoom.onLoad();

          
            },

            setImageSize: function(animate) {




                var img = Site.GalleryView.$el.children().filter("img"),
                iW = img.data("width"),
                iH = img.data("height"),

                _animate = animate || false,

                imgVars = null;

                if ( !img.length ) return; 

                imgVars = Site.GalleryView.getImageSize( iW, iH, Site.GalleryView.w );


                if (_animate === true) {

                    var dT  =        imgVars.tT - parseInt( img.css("top") ),
                    dL      =        imgVars.tL - parseInt( img.css("left") );


                    TweenMax.fromTo(img, dur, {x: 0, y: 0}, { 
                        width: imgVars.tW, 
                        height: imgVars.tH,
                        x: dL,
                        y: dT,
                        z: 0,
                        ease: Quart.easeOut,
                        onComplete: function() {
                            Site.GalleryView.setImageSize(false);
                        }
                    } );

                    return;
                }


                img.removeAttr("style")
                .css({
                    width: imgVars.tW,
                    height: imgVars.tH,
                    left: imgVars.tL,
                    top: imgVars.tT
                });

            },

            setVideoSize: function(animate) {

                console.log("setting size");

                var 
                $video = $("#vimeo"),
                iW = 1200,
                iH = 675,

                _animate = animate || false,

                imgVars = Site.GalleryView.getImageSize( iW, iH, Site.GalleryView.w );

                console.log(imgVars);

                if ( !$video.length ) return;

                console.log("went trough");

                if (_animate === true) {

                    var dT  =        imgVars.tT - parseInt( $video.css("top") ),
                    dL      =        imgVars.tL - parseInt( $video.css("left") );


                    TweenMax.fromTo($video, dur, {x: 0, y: 0}, { 
                        width: imgVars.tW, 
                        height: imgVars.tH,
                        x: dL,
                        y: dT,
                        z: 0,
                        ease: Quart.easeOut,
                        onComplete: function() {
                            Site.GalleryView.setVideoSize(false);
                        }
                    } );

                    return;
                }


                $video.removeAttr("style")
                .css({
                    width: imgVars.tW,
                    height: imgVars.tH,
                    left: imgVars.tL,
                    top: imgVars.tT
                });

            },

            getImageSize: function( iW, iH, w ) {

                var 
                iA = iW/iH,         // image aspect ratio
                tW = iW,            // target image width
                tH = iH,            // target image height
                tT = 0,             // target top offset
                tL = 0,             // target left offset
                gVt = 35,           // gutter vertical - top
                gVb = 65,            // guttre vertical - botttom
                gV = gVt + gVb,            // gutter vertical
                gH = 130,            // gutter horizontal
                mL = (Site.GalleryView.states.enlarged) ? 0 : 291, // left margin to compensate for the info
                wW = w._width - 2 * gH - mL,  // contianer width
                wH = w._height - 2 * gV,    // container height
                a = wW / wH;   // container aspect ratio

                if ( iA > a ) {
                    tW = Math.min(wW, iW);
                    tH = tW / iA;
                }
                else {
                    tH = Math.min(wH, iH);
                    tW = tH * iA;
                }

                tL = (w._width - tW)/2 + mL/2;
                tT = (w._height - tH )/2 - (gVb - gVt);

                return {
                    tW: tW,
                    tH: tH,
                    tL: tL,
                    tT: tT
                };
            },

            hideAll: function() {
            },

            onUnLoad: function() {
            },

            showIndex: function(e) {

                e.preventDefault();

                if ( !Site.GalleryView.states.enlarged ) {
                    Site.GalleryView.toggleEnlarge();
                    return false;
                }

                var img = Site.GalleryView.$el.children().filter("img"),
                next = e.data;


                Site.GalleryView.states.animating = true;

                // TweenMax.to(img, 0.3, {opacity: 0, overwrite: 0});

                // TweenMax.to(img, 0.3, {opacity: 0, x: -next * 200, y: 0, z: 0, easing: Quart.easeIn, overwrite: 0, onComplete: function() {
                TweenMax.to(img, 0.3, {opacity: 0, ease: Quart.easeIn, overwrite: 0, onComplete: function() {

                    Site.GalleryView.states.animating = false;

                    Site.GalleryView.changeCurrent(next);

                    Site.GalleryView.render();

                }});




            },

            changeCurrent: function(v) {

                Site.GalleryView.states.current+=v;

                if( Site.GalleryView.states.current >= Site.GalleryView.images.length ) {
                    Site.GalleryView.states.current = 0;
                }
                else if( Site.GalleryView.states.current < 0 ) {
                    Site.GalleryView.states.current = Site.GalleryView.images.length - 1;
                }

                // Site.GalleryView.states.direction = v;

            },

            resizeTime: null,

            onResize: function() {
                clearTimeout(Site.GalleryView.resizeTime);
                Site.GalleryView.resizeTime = setTimeout(Site.GalleryView.doResize, 250);
            },

       
           

            doResize: function(animate) {


                console.log("checking - mobile: ");

                console.log(Site.Layout.isMobile);

                if ( Site.GalleryView.states.mobile !== Site.Layout.isMobile ) {
                    Site.GalleryView.render();
                    return;
                }

                if( ! Site.GalleryView.states.loaded ) return;

                var _animate = animate || false;

                Site.GalleryView.w._width = Site.GalleryView.$el.width();
                Site.GalleryView.w._height = Site.GalleryView.$el.height();


                Site.GalleryView.setImageSize(_animate);
                Site.GalleryView.setVideoSize(_animate);


            },

            enlarge: function() {

                Site.GalleryView.states.enlarged = true;
                Site.GalleryView.doResize(true);


            },

            toggleEnlarge: function() {
                Site.GalleryView.states.enlarged = (Site.GalleryView.states.enlarged) ? false : true;
                Site.GalleryView.doResize(true);
                $("#artist").toggleClass("is-enlarged");

                // remove the scrollbars on PCs
                Site.Scrolling.onUnLoad();

                // TweenMax.fromTo(Site.GalleryView.$el.find(".gallery-info"), 0.3, {x: 0}, {x: -140, ease: Quart.easeOut});
            },

            unEnlarge: function() {

                if (! Site.GalleryView.states.enlarged ) return;

                Site.GalleryView.states.enlarged = false;
                Site.GalleryView.doResize(true);
                $(".is-enlarged").removeClass("is-enlarged");


                // TweenMax.fromTo(Site.GalleryView.$el.find(".gallery-info"), 0.3, {x: 0}, {x: 0, ease: Quart.easeOut, onComplete: function(){
                    Site.Scrolling.onLoad();
                // }});
            },


            Mobile: {
                render: function() {
                    

                    Site.GalleryView.destroyVideo();


                    Site.GalleryView.states.mobile = true;
                    Site.GalleryView.states.enlarged = false;

              

                    $(".is-enlarged").removeClass("is-enlarged");
                    Site.GalleryView.$el.find("img").remove();

                    var code = '<ul class="mobile-gallery">',
                    template = '<li><img src="{{src}}" {{zoom}} /><h3>{{info}}</h3></li>',
                    templateVideo = '<li><div class="mobile-gallery-video">{{video}}</div><h3>{{info}}</h3></li>',
                    i = 0,
                    l = Site.GalleryView.images.length;

                    for ( i = 0; i < l; i++ ) {

                     

                        var img = Site.GalleryView.images[i],

                            imgSrc = img.src,
                            info = img.title + "<br>" + img.description,
                            zoom = "";

                        if ( ! "vimeoId" in img ) {
                            img.vimeoId = "";
                        }

                        if ( img.vimeoId !== "") {
                            code += templateVideo.replace("{{video}}", Site.GalleryView.videoCode.replace("{{id}}", img.vimeoId))
                            .replace("{{info}}",info);
                            continue;
                        }

                        if ( "zoomSrc" in img && "zoomWidth" in img && "zoomHeight" in img ) {
                            zoom = 'data-zoom=\'{"src": "'+img.zoomSrc+'", "width": '+img.zoomWidth+', "height": '+img.zoomHeight+'}\'';
                        }

                        code += template.replace("{{src}}",imgSrc)
                        .replace("{{info}}",info)
                        .replace("{{zoom}}",zoom);

                    }


                    code += "</ul>";

                    if ( Site.GalleryView.$el.find(".mobile-gallery") ) Site.GalleryView.$el.find(".mobile-gallery").remove();
                    Site.GalleryView.$el.append(code);


                }
            }


        };
    }(jQuery));

