/*

    This file requires site.js to work

*/


var Site = Site || {},
    $window = $window || $(window),
    $body = $body || $("body");



(function($) {


    Site.PushStates = {
        scrollChange: false,
        noChange: false,
        noscroll: false,
        animation: false,
        nextBgColor: "#ccc",

        oldPage: "",
        newPage: "",

        title: "Co Widac?",


        init: function () {


            if(!Modernizr.history) return;

            History.Adapter.bind(window, 'statechange', Site.PushStates.onState);
        },

        onLoad: function() {
            Site.PushStates.bindLinks();
        },

        cleanUp: function(){

            $(".is-active").removeClass("is-active");
            $(".has-active").removeClass("has-active");

            $body.removeClass("menu-open");

        },

        bindLinks: function (target) {

            if(!Modernizr.history) {
                return;
            }
            target = target || "body";

                    // $(target).find('a').not("[data-history='false']")
                    // .not("[href^='#']").not("[href$='.jpg']")
                    // .not("[target='_blank']")
                    // .not("[href^='mailto:']")

                    $(target)
                    .find("a")
                    .not('[href^="http://'+window.location.host+'"]')
                    .not('[href="#"]')
                    .not('[href^="mailto:"]')
                    .not('[target="_blank"]')
                    .not('[data-history="false"]')

                    .off().on("click.history", function (a) {

                        a.preventDefault();

                        var self = $(this), 
                        animate = self.data("animation"),
                        nextBg = self.data("bg"),

                        state = $(a.currentTarget).attr("href").replace("http://" + window.location.host, "");

                        if ( animate ) {
                            Site.PushStates.animation = animate;
                        }

                        if ( nextBg ) {
                            Site.PushStates.nextBgColor = nextBg;
                        }
                        else {
                            Site.PushStates.nextBgColor = Site.defaultColor;                            
                        }

                        Site.PushStates.oldPage = window.location.pathname;


                        Site.PushStates.newPage = state;
                        console.log(state);

                        window.History.pushState(null, null, state);

                    });

                    // $(target).find('a[href^="http://"]').not('[href^="http://'+window.location.host+'"]').off(".history");

                },
                triggerAnimation: function(){

                },
                onState: function (e) {

                // Chceck if the push state wasn't blocked by other settings                   

                if(Site.PushStates.noChange) {

                    return;

                }

                if(Site.PushStates.scrollChange) { 
                    // called when setting the pushState and title on scrolling

                    Site.PushStates.scrollChange = false;
                    return;
                }

                if( "LuCanvas" in Site ) {
                    Site.LuCanvas.onState( window.location.pathname.split("/")[2] || "" );
                }

                var contentContainer = "#content",

                loadTimeout = null,
                loadedData = "",
                animationTimer = null,

                    // To make referencing easier define the functions here

                    showLoader = function(){
                       $("body").addClass("loading");
                   },  

                   hideLoader = function(){
                       $("body").removeClass("loading");
                   },


                   onDataLoad = function(data){

                    loadedData = data;
                    if(animationTimer === 0) handleLoadedData();

                },

                handleLoadedData = function(){

                        // Function called on successful data load


                        if ( Site.PushStates.animation ) {



                            if ( Site.PushStates.animation in Site.Animation.states ) {
                                Site.Animation.states[Site.PushStates.animation](loadedData);


                                Site.PushStates.animation = false;
                                

                                return;
                            }

                            
                            Site.PushStates.animation = false;
                        }


                        var $loadedContent = $(loadedData).find(contentContainer),

                        title = $loadedContent.attr("data-title") || "",

                        code = "",

                        loadedClass = $loadedContent.attr("class") || "",

                        video = $loadedContent.attr("data-video");


                        // // Change the background
                        // bg = $loadedContent.attr("data-bg");

                        if ( Site.PushStates.nextBgColor ) {
                            $body.css("background", Site.PushStates.nextBgColor );
                        }
                        else {
                            $body.removeAttr("style");
                        }


                        if (video ) {
                            Site.Video.setVideo(video);
                        }

                        Site.onUnLoad();


                            $(contentContainer).removeClass("show-content").html("");//.attr("class","");

                            code = $loadedContent.html();

                            window.scrollTo(0, 0);


                            Site.PushStates.cleanUp();
                            Site.PushStates.setTitle(title);

                            $(contentContainer).removeClass("hide-content").addClass("show-content").append(code).data("title",title);

                            if( $(contentContainer).children().filter(".artist").length ) {
                                Site.Animation.moveLineLeft();
                            }
                            else {
                                Site.Animation.moveLineRight();                                
                            }

                            Site.Animation.showContent();


                            // Update lang change

                            var lang = window.location.pathname.split("/")[1],
                            newLang = (lang === "pl") ? "en" : "pl";


                            $(".header-lang").attr("href", window.location.pathname.replace("/"+lang+"/", "/"+newLang+"/"));

                            Site.callAll("onStateComplete", window.location.pathname.split("/")[2] || "" );
                     

                            Site.onLoad();

                            // Site.PushStates.nextBgColor = false;

                            // Site.Scrolling.scrollToPath(false);



                        };


                // Check if the target path can be found on the current page
                if($("[data-path='" + window.location.pathname + "']").length) {

                    if(!Site.PushStates.noscroll) {

                        // Site.Scrolling.scrollToPath();
                        Site.PushStates.setTitle($("[data-path='" + window.location.pathname + "']").data("title"));
                        $body.removeClass("menu-open");
                    }

                } else if (!Site.PushStates.noscroll) {

                    animationTimer = 600;
                    loadTimeout = setTimeout(function () {
                        animationTimer = 0;

                        if(loadedData !== ""){
                            handleLoadedData();
                        }

                    }, animationTimer);


                    // Site.PushStates.addAnimationClasses();


                    // $("#content").removeClass("show-content").addClass("hide-content");
                    if ( !Site.PushStates.animation ) 
                        Site.Animation.hideContent();

                    // Do the actual AJAX request

                    var path = window.location.pathname || "",
                    search = window.location.search || "";

                    $.ajax({
                        url: path + search,
                        global: false,
                        type: "POST",
                        dataType: "html",
                        async: true,

                        success: onDataLoad,
                        error: function () {
                         window.location = "http://"+window.location.host;
                     }
                 });
                    return;
                }

                // Didn't laod - look for the paths on current site
                if(!Site.PushStates.noscroll) {
                    Site.Scrolling.scrollToPath();
                } else {
                    Site.PushStates.noscroll = false;
                }


            },
            setTitle: function(title){
                var _title = title || $("#content").data("title"); 
                document.title = _title;
            },
            goTo: function(loc){
                if(Modernizr.history)   window.History.pushState(null, null, loc.replace("http://" + document.location.host, ""));
                else                    window.location = loc;
            }
        };
    }(jQuery));




    (function($){
        Site.Images = {
            onLoad: function() {

                $(".loading").each(function(i,o){
                    $(o).imagesLoaded(function(){
                        $(o).removeClass("loading");
                    });
                });

            }
        };
    }(jQuery));



    (function($){
        Site.Layout = {
            isMobile: false,
            onLoadFirst: function() {
                Site.Layout.isMobile = Site.Layout.check();
            },
            check: function() {

                if ( parseInt($(".header").css("height")) < 60 ) {
                    return true;
                }
                else {
                    return false;
                }

            },
            onResize: function() {
                Site.Layout.isMobile = Site.Layout.check();
            }
        };
    }(jQuery));


    (function($){
        Site.Retina = {
            onLoadFirst: function() {
                // Site.Layout.check();
                // if(!Site.Layout.isRetina || Site.Layout.isMobile) return;
                // $("img[data-retina]").each(function(i, o){
                //     var img = $(o);
                //     img.attr("src", img.attr("data-retina"));
                // });
            }
        }
    }(jQuery));
