/*

    This file requires site.js to work

*/
var Site = Site || {};


(function ($) {
    Site.Video = {

        showing: false,
        init: function () {


            if (Modernizr.touch || $(".lt-ie9").length) {
                // handle no video
                var images = '<div id="co-images" class="co-images">';

                for (var i = 1; i <= 10; i++) {
                    images += '<img src="/public/cowidac/images/animate/' + i + '.jpg" style="opacity: 0">';
                }

                images += '</div>';

                $("#co-video-wrap").append(images);

                $("#co-video").hide();

                $("#co-images").find("img").eq(0).imagesLoaded(Site.Video.doAnimation);


                return;

            }

            if (!$("#co-video").length) return;

            var video = $("#co-video").removeClass("is-hidden").get(0),


                images = '<div id="co-images" class="co-images">';

            // images += '<img src="/public/cowidac/images/animate/video.png" class="loading">';

            // images += '</div>';

            // $("#co-video-wrap").append(images);


            // $(video).on("ended", video.play);

            // if (typeof video.loop == 'boolean') {
            //     video.loop = true;
            // } else {
                video.addEventListener('ended', function () {
                    this.currentTime = 0;
                    this.play();
                }, false);
            // }

            video.addEventListener('timeupdate', function () {
                if (Site.Video.showing) return;


                Site.Video.showing = true;
                TweenLite.to($("#co-video"), 0.4, {
                    opacity: 1,
                    onComplete: function () {
                        // $("#co-images").find("img").css({
                        //     opacity: 0
                        // });
                    }
                });

            }, false);


            video.play();

            Site.Video.onResize();



            // $("#co-video-wrap").addClass("is-visible");

        },
        fallbackInterval: null,

        doAnimation: function () {

            Site.Video.clearAnimation();

            var current = 0,
                l = 10,
                animateIt = function () {

                    var img = $("#co-images").find("img").eq(current),
                        next = (current + 1 < l) ? current + 1 : 0,
                        nextImg = $("#co-images").find("img").eq(next);



                    TweenLite.to(img, 1, {
                        delay: 0.2,
                        opacity: 0
                    });
                    TweenLite.to(nextImg, 0.6, {
                        opacity: 1
                    });

                    current = next;


                };

            TweenLite.to($("#co-images").find("img").eq(current), 0.4, {
                opacity: 1
            });
            Site.Video.fallbackInterval = setInterval(animateIt, 1200);

        },

        clearAnimation: function() {
            clearInterval(Site.Video.fallbackInterval);
        },

        onResize: function () {

            // if( !$("#co-video").length ) return; 

            var aspect = parseFloat($("#co-video").data("aspect")),
                video = $("#co-video"),
                images = $("#co-images").find("img"),
                wWidth = $window.width(),
                wHeight = Math.max(460, $window.height()),
                windowAspect = wWidth / wHeight,
                wrap = $("#co-video-wrap"),
                vWidth = wWidth,
                vHeight = wHeight,
                vTop = 0,
                vLeft = 0;


            if (aspect > windowAspect) {
                vWidth = vHeight * aspect;
                vLeft = (wWidth - vWidth) / 2;
            } else {
                vHeight = vWidth / aspect;
                vTop = (wHeight - vHeight) / 2;
            }

            if (video) {

                video.css({
                    width: vWidth,
                    height: vHeight,
                    top: vTop,
                    left: vLeft
                });

            }
            if (images) {

                images.css({
                    width: vWidth,
                    height: vHeight,
                    top: vTop,
                    left: vLeft
                });

            }


        },

        setVideo: function (newVideo) {



            var
            $video = $("#co-video"),
                video = $video.get(0),
                oldVideo = video.currentSrc,
                parts = oldVideo.split("/public");

            if (!newVideo) return;


            if (parts.length > 1) {
                oldVideo = "/public" + parts[1];
            }

            if (newVideo !== oldVideo) {


                Site.Video.showing = false;
                TweenLite.to($("#co-video"), 0.4, {
                    opacity: 0,
                    onComplete: function () {

                        video.src = newVideo;
                        video.load();
                        video.play();

                    }
                });
            }

        },

        onLoad: function (page) {

            // console.log("on state complete called");

            if ($("#artist").length) {


                if (Modernizr.touch || $(".lt-ie9").length) {
                    Site.Video.clearAnimation();
                    return;
                }

                $("#co-video").hide();

         

            } else {


                if (Modernizr.touch || $(".lt-ie9").length) {
                    Site.Video.doAnimation();
                    return;
                }

                var $video = $("#co-video"),
                video = $video.get(0);

                $video.show();

                video.addEventListener('ended', function () {
                    this.currentTime = 0;
                    this.play();
                }, false);

                video.play();

            }

        }




    };
}(jQuery));