/*

    This file requires site.js to work

*/
var Site = Site || {};


Site.Zoom = function ($) {

    var touch = [0, 0],
        imagePos = [0, 0];

        $zoom = null,
        zoomData = null,

        template = "<div id=\"zoom\"><img src=\"{{src}}\"><a class=\"zoom-close\" href=\"#\">x</a></div>",

        zoom = function (e) {

            e.preventDefault();


            // Specific to co Widać
            if ( !Site.GalleryView.states.enlarged && !Site.GalleryView.states.mobile ) {
                Site.GalleryView.toggleEnlarge();
                return false;
            }

            zoomData = null;

            if ($zoom) $zoom.remove();
            e.stopPropagation();

            var img = template.replace("{{src}}",$(e.currentTarget).attr("src"));

            zoomData = $(e.currentTarget).data("zoom");

            $("#content")
                .append(img);
            $zoom = $("#zoom");

            $zoom.find("img")
       
                .width(zoomData.width)
                .height(zoomData.height)
                .attr('src', zoomData.src);

                

            resize();

            $zoom.find(".zoom-close").off().on("click", zoomreset);

            if (!Modernizr.touch) {
                $zoom.off().on('mousemove.zoom', zoomupdate)
                    // .on("mouseleave.zoom", zoomreset)  // uncomment if its not a fullscreen zoom
                    .on("click.zoom", zoomreset);



                    setPosition(e);
                    
            } else {
    
                $zoom.off().on("touchmove.zoom", onTouchMove)
                    .on("touchstart.zoom", onTouchStart)
                    .on("click.zoom", zoomreset);

                    onTouchStart(e.originalEvent);
                    onTouchMove(e.originalEvent);
            }

            $(window)
                .off(".zoom")
                .on("resize.zoom", resize);
        },
        zoomreset = function (e) {
            $zoom.fadeOut(300, function () {
                $zoom.off(".zoom")
                    .remove();
            });
        },
        onTouchStart = function (je) {
            var e = je.originalEvent,
            $i = $zoom.find("img");
            touch[0] = e.targetTouches[0].pageX;
            touch[1] = e.targetTouches[0].pageY;

            imagePos[0] = parseInt($i.css("left"));
            imagePos[1] = parseInt($i.css("top"));
        },
        onTouchMove = function (je) {



            var e = je.originalEvent,
                pX = e.targetTouches[0].pageX,
                pY = e.targetTouches[0].pageY;

            if (Math.abs(pX - touch[0]) > 10 || Math.abs(pY - touch[1]) > 10) {

                je.preventDefault();
                je.stopPropagation();
                je.stopImmediatePropagation();


                var $i = $zoom.find("img"),
                    h = zoomData.imageHeight,
                    w = zoomData.imageWidth,
                    zh = zoomData.containerHeight,
                    zw = zoomData.containerWidth,


                    // x = (zw - (pX - touch[0]) + $zoom.offset()
                    //     .left) / (zw),
                    // y = (zh - (pY - touch[1]) + $zoom.offset()
                    //     .top) / (zh);

                    dX = pX - touch[0],
                    dY = pY - touch[1],

                    iX = imagePos[0] + dX,
                    iY = imagePos[1] + dY;

                    iX = Math.min(0, iX);
                    iX = Math.max(zw - w, iX);

                    iY = Math.min(0, iY);
                    iY = Math.max(zh - h, iY);


                    if ( w < zw ) iX = (zw - w)*0.5;
                    if ( h < zh ) iY = (zh - h)*0.5;

                    $i.css({
                        left: iX + "px",
                        top: iY + "px"
                    });

                // $i.css({
                //     left: Math.min(0, Math.max(zw - w, (-x * (w - zw)))) + "px",
                //     top: Math.min(0, Math.max(zh - h, (-y * (h - zh)))) + "px"
                // });
            }

        },

        getPosition = function (e) {
                var
                h = zoomData.imageHeight,
                w = zoomData.imageWidth,
                zh = zoomData.containerHeight,
                zw = zoomData.containerWidth,
                x = (e.pageX - zoomData.containerOffset.left) / (zw),
                y = (e.pageY - zoomData.containerOffset.top) / (zh),

                newX = -x * (w - zw),
                newY = -y * (h - zh);


                if ( w < zw ) newX = (zw - w)*0.5;
                if ( h < zh ) newY = (zh - h)*0.5;

                return {
                    newX: newX,
                    newY: newY
                };
        },

        setPosition = function(e) {

            var $i = $zoom.find("img"),
            position = getPosition(e);

            TweenMax.to($i, 0, {x: position.newX + "px", y: position.newY + "px", overwrite: 1});

        },

        zoomupdate = function (e) {

            var $i = $zoom.find("img"),
            position = getPosition(e);

            TweenMax.to($i, 0.2, {x: position.newX + "px", y: position.newY + "px", overwrite: 1});
            
           
        },
        resize = function () {

            var $i = $zoom.find("img");

            zoomData = zoomData || {};
            zoomData.imageWidth = $i.width();
            zoomData.imageHeight = $i.height();
            zoomData.containerWidth = $zoom.width();
            zoomData.containerHeight = $zoom.height();
            zoomData.containerOffset = $zoom.offset();

            if (!$zoom.length) $(window).off(".zoom");
        };

    return {
        onLoad: function () {
            $("[data-zoom]")
                .off(".zoominit")
                .on("click.zoominit", zoom);
        }
    };
}(jQuery);