/*

________/\\\\\\\\\_______/\\\\\_________________/\\\______________/\\\__/\\\\\\\\\\\__/\\\\\\\\\\\\________/\\\\\\\\\___________/\\\\\\\\\_        
 _____/\\\////////______/\\\///\\\______________\/\\\_____________\/\\\_\/////\\\///__\/\\\////////\\\____/\\\\\\\\\\\\\______/\\\////////__       
  ___/\\\/_____________/\\\/__\///\\\____________\/\\\_____________\/\\\_____\/\\\_____\/\\\______\//\\\__/\\\/////////\\\___/\\\/___________      
   __/\\\______________/\\\______\//\\\___________\//\\\____/\\\____/\\\______\/\\\_____\/\\\_______\/\\\_\/\\\_______\/\\\__/\\\_____________     
    _\/\\\_____________\/\\\_______\/\\\____________\//\\\__/\\\\\__/\\\_______\/\\\_____\/\\\_______\/\\\_\/\\\\\\\\\\\\\\\_\/\\\_____________    
     _\//\\\____________\//\\\______/\\\______________\//\\\/\\\/\\\/\\\________\/\\\_____\/\\\_______\/\\\_\/\\\/////////\\\_\//\\\____________   
      __\///\\\___________\///\\\__/\\\_________________\//\\\\\\//\\\\\_________\/\\\_____\/\\\_______/\\\__\/\\\_______\/\\\__\///\\\__________  
       ____\////\\\\\\\\\____\///\\\\\/___________________\//\\\__\//\\\_______/\\\\\\\\\\\_\/\\\\\\\\\\\\/___\/\\\_______\/\\\____\////\\\\\\\\\_ 
        _______\/////////_______\/////______________________\///____\///_______\///////////__\////////////_____\///________\///________\/////////__


    This is the script that controls automatic exection of other scripts.
    It was created to work with pushStates.

    The script looks through all objects inside Site looking for "init", "onLoad", "onLoadFirst", "onUnLoad" and "onResize" functions:

    "init" is called first, after the DOM is ready
    "onLoad" is called after every pushState and after "init". "onLoad" calls "onLoadFirst" first.
    "onUnLoad" is called after exiting a page via a pushState
    "onResize" is called exactly then

    You can add as many snippets of JS as you want, but site.js should go first.

    The following code, part of "site.js" initializes the whole thing:

    (function($) {

        $window = $(window);
        $body = $("body");
        Site.title = "Co Widac";
        Site.init();

    }(jQuery));


*/



var Site = Site || {},
    $window = $window || jQuery(window),
    $body = $body || jQuery("body"),
    debug = false,
    console = (debug) ? console : {log: function(){return true;}};


(function($){

        var SiteMethods = {

            callAll: function (f, data) {
                var o,
                que = [];
                for (o in Site) {
                    if (typeof (Site[o]) === "object" && Site[o] !== null) {
                        if (f in Site[o]) {
                            if ( "que" in Site[o] ) {
                                que.push(Site[o]);
                            }
                            else {
                                Site[o][f](data);
                            }
                        }
                    }
                }
                for (var qued in que) {
                    que[qued][f](data);
                }
            },
            onLoad: function () {
                Site.callAll("onLoadFirst");
                Site.callAll("onLoad");
            },
            onUnLoad: function () {
                Site.callAll("onUnLoad");
            },
            onResize: function () {
                Site.callAll("onResize");
            },
            init: function () {

                var lang = $("html").attr("lang");
                if( lang != "pl" ) {
                    Site.lang == lang;
                }

                Site.callAll("init");

                Site.onLoad();

                $window.on("resize", Site.onResize);
                Site.onResize();

            },
            lang: "en"
        };

        $.extend(Site, SiteMethods);

}(jQuery));



(function($) {

    $window = $(window);
    $body = $("body");
    Site.title = "Co widać?";
    Site.defaultColor = "#ccc";
    Site.init();

}(jQuery));
